<html>
<head>
<title>OgreShadowCameraSetupLiSPSM.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShadowCameraSetupLiSPSM.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShadowCameraSetupLiSPSM_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2006 Matthias Fink, netAllied GmbH &lt;matthias.fink@web.de&gt;                             </span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00011"></a>00011 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00012"></a>00012 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00013"></a>00013 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00014"></a>00014 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00015"></a>00015 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00018"></a>00018 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00021"></a>00021 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00022"></a>00022 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00023"></a>00023 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00024"></a>00024 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00025"></a>00025 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00026"></a>00026 <span class="comment">THE SOFTWARE.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ShadowCameraSetupLiSPSM_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowCameraSetupLiSPSM_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShadowCameraSetupFocused_8h.html">OgreShadowCameraSetupFocused.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre 
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00098"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html">00098</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup.html" title="Implements the uniform shadow mapping algorithm in focused mode.">FocusedShadowCameraSetup</a>
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100     <span class="keyword">protected</span>:
<a name="l00102"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#aae134702a175b3f5048364a6e44a0a12">00102</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#aae134702a175b3f5048364a6e44a0a12" title="Warp factor adjustment.">mOptAdjustFactor</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a10db7404fd7ff4b65920f35a1e7412d9">00104</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a10db7404fd7ff4b65920f35a1e7412d9" title="Use simple nopt derivation?">mUseSimpleNOpt</a>;
<a name="l00106"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a8f19ca6267277f0654ea89aab138b433">00106</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a8f19ca6267277f0654ea89aab138b433" title="Extra calculated warp factor.">mOptAdjustFactorTweak</a>;
<a name="l00108"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a7f8d800b3c18bbe611077de72bca2fb5">00108</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a7f8d800b3c18bbe611077de72bca2fb5" title="Threshold (cos angle) within which to start increasing the opt adjust as camera direction approaches ...">mCosCamLightDirThreshold</a>;
<a name="l00109"></a>00109 
<a name="l00125"></a>00125         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> calculateLiSPSM(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; lightSpace, <span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; bodyB, 
<a name="l00126"></a>00126             <span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; bodyLVS, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>&amp; sm, 
<a name="l00127"></a>00127             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00153"></a>00153         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculateNOpt(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; lightSpace, <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; bodyBABB_ls, 
<a name="l00154"></a>00154             <span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; bodyLVS, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam) <span class="keyword">const</span>;
<a name="l00155"></a>00155 
<a name="l00158"></a>00158         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculateNOptSimple(<span class="keyword">const</span> <a class="code" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html" title="Internal class holding a point list representation of a convex body.">PointListBody</a>&amp; bodyLVS, 
<a name="l00159"></a>00159             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam) <span class="keyword">const</span>;
<a name="l00160"></a>00160 
<a name="l00171"></a>00171         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> calculateZ0_ls(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; lightSpace, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; e, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bodyB_zMax_ls, 
<a name="l00172"></a>00172             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>&amp; cam) <span class="keyword">const</span>;
<a name="l00173"></a>00173 
<a name="l00179"></a>00179         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> buildFrustumProjection(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom, 
<a name="l00180"></a>00180             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> near, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> far) <span class="keyword">const</span>;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     <span class="keyword">public</span>:
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a>(<span class="keywordtype">void</span>);
<a name="l00188"></a>00188 
<a name="l00193"></a>00193         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a>(<span class="keywordtype">void</span>);
<a name="l00194"></a>00194 
<a name="l00201"></a>00201         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getShadowCamera(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *sm, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *cam, 
<a name="l00202"></a>00202             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a> *light, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *texCam, <span class="keywordtype">size_t</span> iteration) <span class="keyword">const</span>;
<a name="l00203"></a>00203 
<a name="l00216"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#aa4f0c58ca0ea89aa7e4b11def4976ea6">00216</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#aa4f0c58ca0ea89aa7e4b11def4976ea6" title="Adjusts the parameter n to produce optimal shadows.">setOptimalAdjustFactor</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> n) { mOptAdjustFactor = n; }
<a name="l00220"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#aaf7b2c705eff6b04d001279e7ad5b846">00220</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#aaf7b2c705eff6b04d001279e7ad5b846" title="Get the parameter n used to produce optimal shadows.">getOptimalAdjustFactor</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mOptAdjustFactor; }
<a name="l00224"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#ae09cafbe81832dd23c70f85d9435b213">00224</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#ae09cafbe81832dd23c70f85d9435b213" title="Sets whether or not to use a slightly simpler version of the camera near point derivation (default is...">setUseSimpleOptimalAdjust</a>(<span class="keywordtype">bool</span> s) { mUseSimpleNOpt = s; }
<a name="l00228"></a><a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a8fc373347be0c44cc787ff984e3a861f">00228</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1LiSPSMShadowCameraSetup.html#a8fc373347be0c44cc787ff984e3a861f" title="Gets whether or not to use a slightly simpler version of the camera near point derivation (default is...">getUseSimpleOptimalAdjust</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseSimpleNOpt; }
<a name="l00229"></a>00229 
<a name="l00238"></a>00238         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCameraLightDirectionThreshold(<a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a> angle);
<a name="l00239"></a>00239 
<a name="l00244"></a>00244         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a> getCameraLightDirectionThreshold() <span class="keyword">const</span>;
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247     };
<a name="l00251"></a>00251 }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 <span class="preprocessor">#endif</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
